<?php
defined('APP') or die('Hacking attemp!');
class Controller_Member extends Core_Controller{
	private $data;
	private $result;
	public function __construct(){
		parent::__construct();
		parent::loadModel('member');
		$this->view->strfoot = $this->model->cfsite['Copyright'];
		$this->view->sitename = $this->model->cfsite['SiteName'];
		$this->view->adminemail = $this->model->cfsite['AdminEmail'];
    	}
    public function indexAction(array $param){
		die('Access denied !!');
    	}
	public function signupAction(array $param){
		$this->view->title_url = array('ptitle'=>'Signing up - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsignup'])){
			if(empty($_POST['fullname']) || trim($_POST['fullname'])=='')
				$this->view->err_f = 'Please enter your name';
			elseif(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter your email';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Your email invalid';
			elseif($this->model->UserExits(trim($_POST['email'])))
				$this->view->err_e = 'This email already in used';
			elseif(!empty($_POST['txtyear']) && intval($_POST['txtyear'])>date('Y'))
				$this->view->err_d = 'Year of birthday must be less than current year';
			elseif(($_POST['ssmonth']>0 || $_POST['ssday']>0 || !empty($_POST['txtyear'])) && !checkdate(intval($_POST['ssmonth']), intval($_POST['ssday']), intval($_POST['txtyear'])))
				$this->view->err_d = 'Birth day invalid';
			elseif(empty($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter password';
			elseif(trim($_POST['password']) != trim($_POST['repassword']))
				$this->view->err_v = 'Please verify password';
			elseif(empty($_POST['code']) || trim($_POST['code'])=='')
				$this->view->err_c = 'Please enter security code';
			elseif(trim($_POST['code']) != $_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				$strrandom = sha1($this->random_string(32).trim($_POST['email']).trim($_POST['code']));
				$this->data = array('Email' => "'".addslashes(trim($_POST['email']))."'", 'FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['txtyear']).'-'.$_POST['ssmonth'].'-'.$_POST['ssday']."'", 'Password' => "'".md5(trim($_POST['code']).trim($_POST['password']))."'", 'RandomStr' => "'".trim($_POST['code'])."'", 'StrActive' => "'".$strrandom."'", 'IsActive' => 0, 'SignedDate' => "'".date('Y-m-d')."'", 'LastLogin' => 'NULL', 'IpAddress' => "'".$this->IpAddress()."'");
				$this->result = $this->model->NewUser($this->data);
				if($this->result>0){
					$this->view->succ = 'Thank you registered members !<br>Please check your email to active account';
					$mess = 'Dear, '.$_POST['email'].' !!<br><br>Please <a href="'.BASE_URL.'?member&active&str='.$strrandom.'">click here</a> to active account on '.$this->model->cfsite['SiteName'].'<br><br>
Best regards !';
					@mail(trim($_POST['email']), '=?UTF-8?B?'.base64_encode('Active account '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
					}
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->render('members/signup');
    	}
	public function signoutAction(){
		unset($_SESSION['uid']);
		unset($_SESSION['umail']);
		unset($_SESSION['ugrou']);
		header('Location: '.BASE_URL);
		return;
    	}
	public function signinAction(){
		$this->view->title_url = array('ptitle'=>'Signing in - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsignin'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter your email';
			elseif(empty($_POST['password']) || trim($_POST['password'])=='')
				$this->view->err_p = 'Please enter password';
			else{
				$this->data = array(trim($_POST['email']),trim($_POST['password']), $this->IpAddress());
				$this->result = $this->model->MemberSignin($this->data);
				if($this->result[0]>0){
					$_SESSION['uid'] = $this->result[0];
					$_SESSION['umail'] = trim($_POST['email']);
					$_SESSION['ugrou'] = 1;
					header('Location: '.BASE_URL.'?member&account');
					}
				elseif($this->result[0]==-1)
					$this->view->error = 'An error occurred, please try again';
				elseif($this->result[0]==-2)
					$this->view->error = 'Email or password incorrect';
				elseif($this->result[0]==-3)
					$this->view->error = 'Your account is not active';
				elseif($this->result[0]==-4)
					$this->view->error = 'Can not check for ban user';
				elseif($this->result[0]==-5)
					$this->view->error = '<i>Your account has banned.<br>Reason: '.$this->result[1].'<br>Banned date: '.$this->result[2].'</i>';
				}
			}
		$this->view->render('members/signin');
    	}
	public function activeAction(array $param){
		if(!array_key_exists('str',$param) || empty($param['str']))
			die('Your bad URL !!');
		$this->view->title_url = array('ptitle'=>'Active account - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->result = $this->model->ActiveAccount($param['str']);
		if(is_array($this->result)){
			$_SESSION['uid'] = $this->result['Id'];
			$_SESSION['umail'] = $this->result['Email'];
			$_SESSION['ugrou'] = 1;
			$this->view->succ = 'Active account successfull !';
			}
		elseif($this->result==-1)
			$this->view->error = 'An error occurred, please try again';
		elseif($this->result==-2)
			$this->view->exits = 'Your account is actvied !!';
		elseif($this->result==-3)
			$this->view->error = 'Your data invalid or incorrect';
		elseif($this->result==-4)
			$this->view->error = 'Can not update status active account';
		$this->view->render('members/active');
    	}
	public function forgotAction(){
		$this->view->title_url = array('ptitle'=>'Recovery password - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smforgot'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter your email';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Your email invalid';
			elseif(!$this->model->UserExits(trim($_POST['email'])))
				$this->view->err_e = 'This email is not exits';
			elseif(empty($_POST['code']) || trim($_POST['code'])=='')
				$this->view->err_c = 'Please enter security code';
			elseif(trim($_POST['code']) != $_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				$strrandom = sha1($this->random_string(32).trim($_POST['email']).trim($_POST['code']));
				$this->data = array(addslashes(trim($_POST['email'])), $strrandom);
				$this->result = $this->model->RequirePassword($this->data);
				if($this->result>0){
					$this->view->succ = 'Thank you for used our service !<br>Please check your email for new password';
					$mess = 'Dear, '.$_POST['email'].' !!<br><br>Please <a href="'.BASE_URL.'?member&reset&str='.$strrandom.'">click here</a> to reset password on '.$this->model->cfsite['SiteName'].'<br><br>
Best regards !';
					@mail(trim($_POST['email']), '=?UTF-8?B?'.base64_encode('Reset password - '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
					}
				elseif($this->result==-1) $this->view->error = 'An error occurred, please try again';
				elseif($this->result==-2) $this->view->error = 'This email is not exits';
				elseif($this->result==-3) $this->view->error = 'Your account is not active';
				elseif($this->result==-4) $this->view->error = 'Can not update your password, please try again';
				}
			}
		$this->view->render('members/forgot');
    	}
	public function resetAction(array $param){
		if(!array_key_exists('str',$param) || empty($param['str']))
			die('Your bad URL !!');
		$this->view->title_url = array('ptitle'=>'Reset password - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		if(!$this->model->ValidParam($param['str']))
			$this->view->invalid = 'Your data invalid';
		else{
			if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smreset'])){
				if(empty($_POST['password']) || trim($_POST['password'])=='')
					$this->view->err_p = 'Please enter password';
				elseif(trim($_POST['password']) != trim($_POST['repassword']))
					$this->view->err_v = 'Please verify password';
				else{
					$strrandom = $this->random_string(6);
					$this->data = array($param['str'], md5($strrandom.trim($_POST['password'])), $strrandom);
					$this->result = $this->model->ResetPassword($this->data);
					if($this->result>0)	$this->view->succ = 'Your password changed successfull !<br>Please <a href="'.BASE_URL.'?member&signin">sign-in here</a>';
					elseif($this->result==-1) $this->view->error = 'An error occurred, please try again';
					elseif($this->result==-2) $this->view->error = 'This email is not exits';
					elseif($this->result==-3) $this->view->error = 'Your account is not active';
					elseif($this->result==-4) $this->view->error = 'Can not update your password, please try again';
					}
				}
			}
		$this->view->render('members/reset');
    	}
	public function accountAction(){
		if(!isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smupdate'])){
			if(empty($_POST['fullname']) || trim($_POST['fullname'])=='')
				$this->view->err_f = 'Please enter your name';
			elseif(!empty($_POST['txtyear']) && intval($_POST['txtyear'])>date('Y'))
				$this->view->err_d = 'Year of birthday must be less than current year';
			elseif(($_POST['ssmonth']>0 || $_POST['ssday']>0 || !empty($_POST['txtyear'])) && !checkdate(intval($_POST['ssmonth']), intval($_POST['ssday']), intval($_POST['txtyear'])))
				$this->view->err_d = 'Birth day invalid';
			else{
				$_err = 0;
				$filename = NULL;
				if(!empty($_FILES['photo']['name'])){
					$extension = pathinfo($_FILES['photo']['name']);
					$extension = $extension['extension'];
					list($width, $height, $type, $w) = getimagesize($_FILES['photo']['tmp_name']);
					if($_FILES['photo']['size']/1024 > 50000){
						$this->view->err_p = 'Max file size is 5MB';
						$_err = 1;
						}
					elseif(!in_array(strtolower($extension), array('gif','jpg','jpeg','png'))){
						$this->view->err_p = 'File format is \'gif, jpg, jpeg, png\'';
						$_err = 1;
						}
					elseif($width>115 || $height>115){
						$this->view->err_p = 'Width and Height max is 115 pixels';
						$_err = 1;
						}
					else{
						$temp = $this->random_string(16);
						$filename = $temp.'.'.$extension;
						if(!move_uploaded_file($_FILES['photo']['tmp_name'],dirname(dirname(__FILE__)).'/public/fuploads/'.$filename)){
							$this->view->err_p = 'An error while upload file';
							$_err = 1;
							}				
						}
					}
				if(intval($_err)==0){
					$data = array('FullName' => "'".addslashes(trim($_POST['fullname']))."'", 'Birthday' => "'".trim($_POST['txtyear']).'-'.$_POST['ssmonth'].'-'.$_POST['ssday']."'", 'Photo' => "'".$filename."'", 'Gender' => $_POST['gender'], 'MobileNumber' => "'".addslashes(trim($_POST['mobile']))."'", 'RelationshipId' => $_POST['relationship'], 'Location' => "'".addslashes(trim($_POST['location']))."'", 'Religion' => "'".addslashes(trim($_POST['religion']))."'");
					if($this->model->UpdateProfile($data, $_SESSION['uid'])>0)
						$this->view->succ = 'Your profile updated successfull';
					else $this->view->error = 'An error occurred, please try again';
					}
				}
			}
		$this->view->mnsys =2;
		$this->view->title_url = array('ptitle'=>'Account settings - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->view->genders = $this->model->getGender();
		$this->view->relationship = $this->model->getRelationship();
		$this->view->user = $this->model->getAccInfomation($_SESSION['uid']);
		$this->view->render('members/account');
    	}
	public function changepassAction(){
		if(!isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		$this->view->title_url = array('ptitle'=>'Change password - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsavepass'])){
			if(empty($_POST['curpassword']) || trim($_POST['curpassword'])=='')
				$this->view->err_cp = 'Please enter current password';
			elseif(!$this->model->verifyPassword(trim($_POST['curpassword']), $_SESSION['uid']))
				$this->view->err_cp = 'Current password incorrect';
			elseif(empty($_POST['nepassword']) || trim($_POST['nepassword'])=='')
				$this->view->err_p = 'Please enter new password';
			elseif(trim($_POST['nepassword'])!=trim($_POST['repassword']))
				$this->view->err_v = 'Please varify new password';
			else{
				$strrandom = $this->random_string(6);
				$this->data = array($_SESSION['uid'], md5($strrandom.trim($_POST['nepassword'])), $strrandom);
				$this->result = $this->model->ChangePassword($this->data);
				if($this->result>0)	$this->view->succ = 'Your password changed successfull !';
				elseif($this->result==-1) $this->view->error = 'An error occurred, please try again';
				}
			}
		$this->view->mnsys =2;
		$this->view->psort = 2;
		$this->view->render('members/changepass');
    	}
	public function sentcardAction(array $param){
		if(!isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && $param['a']=='d'){
			if(!$this->model->MemberDelCard(array($param['id'],$_SESSION['umail'])))
				$this->view->error = 'An error occurred, please try again';
			else{
				header('Location: '.BASE_URL.'?member&sentcard');
				return;
				}
			}
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->model->cfsite['RecordsPerPage'];
		$config['js_numrows_page'] = count($this->model->getSentCards($_SESSION['umail'],''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?index&index'.$strquery;
		$paging = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->ttpage = $paging;
		$this->view->title_url = array('ptitle'=>'Sent cards - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->view->sent = $this->model->getSentCards($_SESSION['umail'],$limit);
		$this->view->mnsys =2;
		$this->view->psort = 3;
		$this->view->render('members/sentcard');
    	}
	public function editcardAction(array $param){
		if(!isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		if(!array_key_exists('id',$param) || $param['id']==0)
			die('Your bad URL !!');
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcancel'])){
			header('Location: '.BASE_URL.'?member&sentcard');
			return;
			}
		$result = $this->model->getDetailCard($param['id'],$_SESSION['umail']);
		if(count($result)>0){
			$this->view->carddetail = $result;
			$this->view->title_url = array('ptitle'=>'Edit your card - '.$result[0]['CardName'], 'metadesc'=>'Edit your card - '.$result[0]['CardName'], 'metaimg'=>$result[0]['CardImg'],'metatitle'=>$result[0]['CardName']);
			$this->view->listcate = $this->model->getAllCategories();
			$this->view->fonts = $this->model->getAllFonts();
			$this->view->colors = $this->model->getAllColors();
			if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsavechange'])){
				if($_POST['addmess']=='on' && (empty($_POST['message']) || trim($_POST['message'])==''))
					$this->view->err_m = 'Please enter your message';
				elseif(empty($_POST['receivername']) || trim($_POST['receivername'])=='')
					$this->view->err_rn = 'Please enter receiver name';
				elseif(empty($_POST['receiveremail']) || trim($_POST['receiveremail'])=='')
					$this->view->err_re = 'Please enter receiver email';
				elseif(!$this->valid_email(trim($_POST['receiveremail'])))
					$this->view->err_re = 'Receiver email invalid';
				elseif(strtolower(trim($_POST['receiveremail']))==strtolower($_SESSION['umail']))
					$this->view->err_re = 'Receiver\'s email same with sender\'s email.';
				else{
					$_err = 0;
					$filename = NULL;
					if(!empty($_FILES['musicfile']['name'])){
						$extension = pathinfo($_FILES['musicfile']['name']);
						$extension = $extension['extension'];
						if($_FILES['musicfile']['size']/1024 > 50000){
							$this->view->err_f = 'Max file size is 5MB';
							$_err = 1;
							}
						elseif(!in_array(strtolower($extension), array('mp3'))){
							$this->view->err_f = 'File format is mp3';
							$_err = 1;
							}
						else{
							$temp = $this->random_string(16);
							$filename = $temp.'.'.$extension;
							if(!move_uploaded_file($_FILES['musicfile']['tmp_name'],dirname(dirname(__FILE__)).'/public/ecards/musics/'.$filename)){
								$this->view->err_f = 'An error while upload file';
								$_err = 1;
								}				
							}
						}
					if(intval($_err)==0){
						$istext = $_POST['addmess']=='on'?1:0;
						$isview = $_POST['alert']=='on'?1:0;
						$isnew = $_POST['receiver']=='on'?1:0;
						if(is_null($filename))
							$data = array('RecipientName' => "'".addslashes(trim($_POST['receivername']))."'", 'RecipientEmail' => "'".addslashes(trim($_POST['receiveremail']))."'", 'IsText' => $istext, 'Message' => "'".addslashes(trim(htmlentities($_POST['message'])))."'", 'TopMessage' => intval($_POST['topmess']), 'LeftMessage' => intval($_POST['leftmess']), 'WidthMessage' => intval($_POST['widthmess']), 'HeightMessage' => intval($_POST['heightmess']), 'MessageFont' => "'".addslashes(trim($_POST['messfont']))."'", 'MessageColor' => "'".addslashes(trim($_POST['messcolor']))."'", 'SentDate' => "'".date('Y-m-d H:i:s')."'", 'IsNoticeViewed' => $isview, 'IsNoticeNewCard' => $isnew);
						else $data = array('RecipientName' => "'".addslashes(trim($_POST['receivername']))."'", 'RecipientEmail' => "'".addslashes(trim($_POST['receiveremail']))."'", 'IsText' => $istext, 'Message' => "'".addslashes(trim(htmlentities($_POST['message'])))."'", 'TopMessage' => intval($_POST['topmess']), 'LeftMessage' => intval($_POST['leftmess']), 'WidthMessage' => intval($_POST['widthmess']), 'HeightMessage' => intval($_POST['heightmess']), 'AttachFile' => "'".$filename."'", 'MessageFont' => "'".addslashes(trim($_POST['messfont']))."'", 'MessageColor' => "'".addslashes(trim($_POST['messcolor']))."'", 'SentDate' => "'".date('Y-m-d H:i:s')."'", 'IsNoticeViewed' => $isview, 'IsNoticeNewCard' => $isnew);
						if(!$this->model->SaveChangeCard($data, $param['id'], $_SESSION['umail']))
							$this->view->error = 'An error occurred, please try again';
						else{
							$this->view->succ = 'Your card saved successfull !';
							$mess = 'Dear, '.$_POST['receiveremail'].' !!<br><br>'.$result[0]['SenderName'].' <i>('.$result[0]['SenderEmail'].')</i> sent to you <b>a '.$result[0]['CardCate'].'</b> ecard from '.$this->model->cfsite['SiteName'].'<br><br><a href="'.BASE_URL.'?category&viewmycard&id='.$strid.'">Click here</a> to view ecard.';
							@mail(trim($_POST['receiveremail']), '=?UTF-8?B?'.base64_encode('Send ecard from '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
							}
						}
					}
				}
			}
		$this->view->mnsys =2;
		$this->view->render('members/editcard');
		}
	public function reminderAction(array $param){
		$result = $this->model->getDetailCard($param['id'],$_SESSION['umail']);
		if(!isset($_SESSION['uid']))
			echo json_encode(array("jval"=>-1));
		elseif(!array_key_exists('id',$param) || $param['id']==0 || !array_key_exists('em',$param) || empty($param['em']))
			echo json_encode(array("jval"=>-2));
		elseif(count($result)>0){
			$mess = 'Dear, '.urldecode($_GET['em']).' !!<br><br>'.$result[0]['SenderName'].' <i>('.$result[0]['SenderEmail'].')</i> sent to you <b>a '.$result[0]['CardName'].'</b> ecard from '.$this->model->cfsite['SiteName'].'<br><br><a href="'.BASE_URL.'?category&viewmycard&id='.$result[0]['StringId'].'">Click here</a> to view ecard.';
			@mail(trim(urldecode($_GET['em'])), '=?UTF-8?B?'.base64_encode('Send ecard from '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
			echo json_encode(array("jval"=>1));
			}
		else echo json_encode(array("jval"=>-3));
		}
	public function cardstoAction(array $param){
		if(!isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->model->cfsite['RecordsPerPage'];
		$config['js_numrows_page'] = count($this->model->getReceivedCards($_SESSION['umail'],''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?index&index'.$strquery;
		$paging = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->title_url = array('ptitle'=>'Received cards - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->view->sent = $this->model->getReceivedCards($_SESSION['umail'],$limit);
		$this->view->mnsys =2;
		$this->view->psort = 4;
		$this->view->listblock = $this->model->getListBlock($_SESSION['umail']);
		$this->view->render('members/cardsto');
    	}
	public function blocksenderAction(array $param){
		if(!isset($_SESSION['uid']))
			echo json_encode(array("jval"=>-1));
		elseif(!array_key_exists('em',$param) || empty($param['em']))
			echo json_encode(array("jval"=>-2));
		elseif(!$this->model->BlockSender($_SESSION['umail'], urldecode($param['em'])))
			echo json_encode(array("jval"=>-3));
		else echo json_encode(array("jval"=>1));
		}
	public function unblocksenderAction(array $param){
		if(!isset($_SESSION['uid']))
			echo json_encode(array("jval"=>-1));
		elseif(!array_key_exists('em',$param) || empty($param['em']))
			echo json_encode(array("jval"=>-2));
		elseif(!$this->model->UnBlockSender($_SESSION['umail'], urldecode($param['em'])))
			echo json_encode(array("jval"=>-3));
		else echo json_encode(array("jval"=>1));
		}
	public function mycontactAction(array $param){
		if(!isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		if(array_key_exists('id',$param) && intval($param['id'])>0 && array_key_exists('a',$param) && $param['a']=='d'){
			if(!$this->model->__newDeleteData('contacts',array('Id=' => $param['id'], ' and OwnerId =' =>$_SESSION['uid'])))
				$this->view->error = 'An error occurred, please try again';
			else{
				header('Location: '.BASE_URL.'?member&mycontact');
				return;
				}
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['contactsearch'])){
			if(empty($_POST['ctsearch']) || trim($_POST['ctsearch'])==''){
				header('Location: '.BASE_URL.'?member&mycontact');
				return;
				}
			else{
				header('Location: '.BASE_URL.'?member&mycontact&key='.urlencode($_POST['ctsearch']));
				return;
				}
			}
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smaddcont'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter your email';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Your email invalid';
			elseif($this->model->ContactExits(trim($_POST['email']), $_SESSION['uid']))
				$this->view->err_e = 'This email already in your contact';
			elseif(empty($_POST['fullname']) || trim($_POST['fullname'])=='')
				$this->view->err_f = 'Please enter your friend name';
			elseif(($_POST['ssmonth']>0 || $_POST['ssday']>0 || !empty($_POST['txtyear'])) && !checkdate(intval($_POST['ssmonth']), intval($_POST['ssday']), intval($_POST['txtyear'])))
				$this->view->err_d = 'Birth day invalid';
			else{
				$isbirth = ($_POST['txtyear']>0 && $_POST['ssmonth']>0 && $_POST['ssday']>0)?trim($_POST['txtyear']).'-'.$_POST['ssmonth'].'-'.$_POST['ssday']:'NULL';
				$data = array('OwnerId' => $_SESSION['uid'], 'Email' => "'".trim($_POST['email'])."'", 'FullName' => "'".trim($_POST['fullname'])."'", 'Birthday' => $isbirth, 'AddedDate' => "'".date('Y-m-d H:i:s')."'");
				if($this->model->__newInsertData('contacts',$data)>0)
					$this->view->succ = 'Added successfull';
				else $this->view->error = 'An error occurred, please try again';
				}
			}
		$where = '';
		if(array_key_exists('key',$param) && !empty($param['key']))
			$where = "CONCAT(FullName,' ',Email) like '%".trim(urldecode($param['key']))."%'";
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->model->cfsite['RecordsPerPage'];
		$config['js_numrows_page'] = count($this->model->getAllContact($_SESSION['uid'],$where,''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?member&mycontact'.$strquery;
		$paging = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		$this->view->title_url = array('ptitle'=>'My contacts - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->view->contact = $this->model->getAllContact($_SESSION['uid'],$where,$limit);
		$this->view->mnsys =2;
		$this->view->psort = 5;
		$this->view->render('members/mycontact');
    	}
	public function editcontAction(array $param){
		if(!isset($_SESSION['uid']))
			echo json_encode(array("jval"=>-1));
		else{
			$where = 'Id = '.$param['id'];
			$contact = $this->model->getAllContact($_SESSION['uid'],$where,'');
			if(count($contact)>0){
				$isbirth = (!is_null($contact[0]['Birthday']))?explode('-',$contact[0]['Birthday']):explode('-', '0-0-0');
				$data = array("jval"=>$param['id'], 'mail' => urlencode($contact[0]['Email']), 'name' => urlencode($contact[0]['FullName']), 'day' => $isbirth[2], 'mon' => $isbirth[1], 'year' => $isbirth[0]);
				echo json_encode($data);
				}
			else echo json_encode(array("jval"=>-2));
			}
		}
	public function updatecontAction(array $param){
		if(!isset($_SESSION['uid']))
			echo json_encode(array("jval"=>-7));
		else{
			if(empty($param['email']) || trim(urldecode($param['email']))=='')
				echo json_encode(array("jval"=>-1, 'mess' => 'Please enter your email', 'label' => 'lberr_e'));
			elseif(!$this->valid_email(trim(urldecode($param['email']))))
				echo json_encode(array("jval"=>-2, 'mess' => 'Your email invalid', 'label' => 'lberr_e'));
			elseif(trim(urldecode($param['te']))!=trim(urldecode($param['email'])) && $this->model->ContactExits(trim(urldecode($param['email'])), $_SESSION['uid']))
				echo json_encode(array("jval"=>-3, 'mess' => 'This email already in your contact', 'label' => 'lberr_e'));
			elseif(empty($param['fullname']) || trim(urldecode($param['fullname']))=='')
				echo json_encode(array("jval"=>-4, 'mess' => 'Please enter your friend name', 'label' => 'lberr_f'));
			elseif(($param['ssmonth']>0 || $param['ssday']>0 || !empty($param['txtyear'])) && !checkdate(intval($param['ssmonth']), intval($param['ssday']), intval($param['txtyear'])))
				echo json_encode(array("jval"=>-5, 'mess' => 'Birth day invalid', 'label' => 'lberr_d'));
			else{
				$isbirth = ($param['txtyear']>0 && $param['ssmonth']>0 && $param['ssday']>0)?"'".trim($param['txtyear']).'-'.$param['ssmonth'].'-'.$param['ssday']."'":'NULL';
				$data = array('Email' => "'".trim(urldecode($param['email']))."'", 'FullName' => "'".trim(urldecode($param['fullname']))."'", 'Birthday' => $isbirth, 'AddedDate' => "'".date('Y-m-d H:i:s')."'");
				$cond = array('OwnerId = ' => $_SESSION['uid'], ' and Id = ' => $param['id']);
				if($this->model->__newUpdateData('contacts', $data, $cond)>0)
					echo json_encode(array("jval"=>1, 'mess' => BASE_URL.'?member&mycontact'));
				else echo json_encode(array("jval"=>-6, 'mess' => 'An error occurred, please try again', 'label' => 'lberr_error'));
				}
			}
		}
	}